;
 LIST	P=16F84
 INCLUDE<P16F84.INC>
;
tam 	equ 	0
zpet 	equ 	1
krok 	equ 	0Ch
w_keep 	equ 	0Eh
cas0	equ	12h
cas1	equ	13h
;
;--------------------------------------------------------------------------------
; EEPROM - nepouito
;
	org	0x2100
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
	de	0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF	;
;
;-------------------------------------------------------------------------------------------
; zatek programu
;
	org 	0
	goto 	init
;
	org 	004h
	goto 	rutina
;
;-------------------------------------------------------------------------------------------
; inicializace procesoru
;
init	bsf 	STATUS,5
	movlw 	b'00001111'	; portb(0) vstup potn
	movwf 	TRISB 		; portb(3:1) jako vstupy a portb(4:7) jako vstup (interrupt)
	movlw	b'00000000'
	movwf 	TRISA 		; porta jako vstupy
	bcf 	STATUS,5
	movlw 	b'00000000'
	movwf	krok
	movlw 	b'00000000'	; nulovn
	movwf	PORTA
	movlw 	b'11110000'
	movwf 	PORTB
	bsf	STATUS,5
	bcf	OPTION_REG,INTEDG	; 0 = sestupn hrana impulsu, 1 nbn (default)
	bcf	STATUS,5
	bcf 	INTCON,INTF	; nastaven peruen
	bsf 	INTCON,GIE
	bsf 	INTCON,INTE
;
;-----------------------; !!! hlavn program !!!
;
hlavni	movf 	krok,tam 	; zavolme tabulku pro port B
	call	btable		; tabulka ur rozvcen a zhasnut diody
	movwf	PORTB		; pesuneme na port B
	call	cekej
	goto	hlavni		; zpt na "hlavni"
;
;-------------------------------------------------------------------------------------------
; tabulka pro port B - LED
;
btable	addwf 	PCL,zpet	; krok (1 - nesvt, 0 - svt)
	retlw 	b'11101111' 	; 0
	retlw 	b'10111111' 	; 1
	retlw 	b'11011111' 	; 2
	retlw 	b'01111111' 	; 3
;
;-------------------------------------------------------------------------------------------
; tabulka pro port A - motor
;
atable	addwf 	PCL,zpet	; krok  (1 - nesvt, 0 - svt)
	retlw 	b'00000001' 	; 0
	retlw 	b'00000100' 	; 1
	retlw 	b'00000010' 	; 2
	retlw 	b'00001000' 	; 3
;
;-------------------------------------------------------------------------------------------
;ekn  1 ms
;
cekej	movlw	.2
	movwf	cas1
	movlw	.75
	movwf	cas0
	decfsz	cas0,zpet
	goto	$-1
	decfsz	cas1,zpet
	goto	$-3
	return
;
;-------------------------------------------------------------------------------------------
; obsluha peruen 
;
rutina	bcf 	INTCON,INTE	; zkaz peruen od RB0
	movwf 	w_keep		; w do zlohy
;
	btfsc 	PORTB,0 	; trv impuls?
	goto 	exit
;
	btfss	PORTB,1		; je-li PB1 v 1, pokrauje na 1.smr
	goto	smer2		; je-li PB1 v 0, pokrauje na 2.smr
;
	incf 	krok,zpet	; 1. smr oten
	bcf 	STATUS,C
	movlw	.252 		; je jednotek >= 4?
	addwf 	krok,tam
	btfsc 	STATUS,C	; nen - pesko nulovn
	clrf 	krok		; ano - nulujeme
	movf 	krok,tam 	; zavolme tabulku pro port A
	call	atable		; tabulka ur pipojen vinut
	movwf	PORTA		; pesuneme na port A
	goto	exit
;
smer2	decf	krok,zpet	; 2. smr oten
	btfsc	krok,7		; je obsah registru 255
	movlw	b'00000011'	; ano > naplnme 3
	btfsc	krok,7		; ne > peskakujeme
	movwf	krok
	movf 	krok,tam 	; zavolme tabulku pro port A
	call	atable		; tabulka ur pipojen vinut
	movwf	PORTA		; pesuneme na port A
;
;
exit	bcf 	INTCON,INTF	; povolen peruen
	bsf 	INTCON,GIE
	bsf 	INTCON,INTE
	movf 	w_keep,tam	; zloha do w
;
	return
;
;-------------------------------------------------------------------------------------------
	end
;-------------------------------------------------------------------------------------------


